
-- Uses Jamie's mgen to play kesac's "Obeytown"
-- See https://love2d.org/forums/viewtopic.php?f=5&t=11379&start=10

local beatCounter = 0
-- local beat = 0.42
local beat = 0.33
local music_progress = 1

function love.load()

  mgen        = require 'mgen'
  composition = require 'obeytown'
  
  mgen.init(0.3,'sawtooth')
  
end

function love.update(dt)
 
	beatCounter = beatCounter + dt
	
	if beatCounter > beat then
		beatCounter = 0
		
		for _, section in ipairs(composition) do
		
			noteIndex = section[music_progress]
			
			if noteIndex then
				mgen.notes[noteIndex]:play()
			end
		end
		
		music_progress = music_progress + 1
		
		-- Loop the music
		if music_progress > composition.length then music_progress = 1 end
		
	end
 
end


function love.draw()
	
	love.graphics.print('Currently playing: ' .. composition.name, 50, 50)
	love.graphics.print('Music Progress: ' .. music_progress .. ' / ' .. composition.length, 50, 75)
	
	for i, section in ipairs(composition) do
		
		noteIndex = section[music_progress - 1]
		
		if noteIndex then
			love.graphics.print('Section ' .. i .. ': ' .. noteIndex, 50, 75 + i*25)
		else
			love.graphics.print('Section ' .. i .. ': --', 50, 75 + i*25)
		end
	end
	
end

